"use strict";
this.name = "SE-main-script";
this.author = "Ramirez & Svengali";
this.copyright = "March 2011";
this.description = "Special events for market prices";

//2.6.1 added system marker -spara-
//2.6 fixed to work with Oolite 1.82 -spara-

this.startUp = function()
{
	var harakiri = false;
	// Check for Snoopers and react if not found...
	if(!worldScripts.snoopers) harakiri = true;
	else if(!this.compareVersion(worldScripts.snoopers.version,"2.1.2")) harakiri = true;
	if(harakiri){
		player.consoleMessage("BlOomberg - Minimum Snoopers version (2.1.2) not detected. Disabling...",10);
		log(this.name,this.name+': Minimum Snoopers version (2.1.2) not detected. Disabling all functionality in BlOomberg.');
		for(prop in this){if(prop!=='name' && prop!=='version') delete this[prop];}
		return;
	}
	delete this.compareVersion;
	this.logging = false; // Must be false for release
	this.checkShort = false; // Use short time check. Must be false for release
	if(this.logging) this.getLog('Loaded:');
}
this.clearVars = function()
{
	missionVariables.SE_commodity = null;
	missionVariables.SE_deadline = null;
	missionVariables.SE_deviation = null;
	missionVariables.SE_economy_type = null;
	missionVariables.SE_galaxy_number = null;
	missionVariables.SE_missiontext_string = null;
	missionVariables.SE_set = null;
	missionVariables.SE_status = null;
	missionVariables.SE_system_economy = null;
	missionVariables.SE_system_ID = null;
	missionVariables.SE_system_name = null;
	
	//used in bloomberg_market.js -spara-
	missionVariables.SE_market_key = null;
	
	return;
}
this.compareVersion = function(strA,strB)
{
	var x = strA.split('.'),y = strB.split('.');
	var xl = x.length,yl = y.length;
	for(let i=0;i<yl;i++){
		if(xl<=i) return(false);
		if(parseInt(x[i])>y[i]) break;
		if(parseInt(x[i])<y[i]) return(false);
	}
	return(true);
}
// Check if screens should be passed or event should be reset
this.guiScreenChanged = function()
{
	if(player.ship.docked && guiScreen === "GUI_SCREEN_MARKET") this.prepareScreen();
}
this.shipExitedWitchspace = function()
{
	if(missionVariables.SE_status === "RUNNING" && clock.days > missionVariables.SE_deadline) this.prepareScreen();
}
this.shipWillEnterWitchspace = function(type)
{
	if(type === "galactic jump") this.resetSpecialEvent();
}
// Prepare screen for Snoopers
this.prepareScreen = function()
{
	if(!missionVariables.SE_status){
		var event_delay = Math.floor(Math.random()*10) + 20;
		if(this.checkShort) missionVariables.SE_set = clock.days;
		else missionVariables.SE_set = clock.days + event_delay;
		missionVariables.SE_status = "SET";
	}
	if(this.logging) log(this.name,this.name+': Set is:'+missionVariables.SE_set);
	var obj = new Object();
	if(missionVariables.SE_status === "RUNNING"){
		if(this.logging) log(this.name,this.name+': Deadline:'+missionVariables.SE_deadline);
		if(clock.days >= missionVariables.SE_deadline){
			obj = {ID:this.name,Message:expandMissionText("SE_reset_event"),Pic:"SE-bloomberg.png",Music:"SE-stockmarket.ogg",Priority:1};
			this.passScreen(obj,null);
		}
		return;
	} else if(clock.days >= missionVariables.SE_set && missionVariables.SE_status === "SET"){
		missionVariables.SE_system_ID = (Math.floor(Math.random()*255));
		missionVariables.SE_galaxy_number = galaxyNumber;
		missionVariables.SE_system_name = System.systemNameForID([missionVariables.SE_system_ID]);
		missionVariables.SE_system_economy = System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).economy;
		if(missionVariables.SE_system_economy > 3){
			missionVariables.SE_economy_type = "agricultural";
			missionVariables.SE_commodity = expandDescription("[SE_agricultural_commodity]");
			missionVariables.SE_deviation = expandDescription("[SE_"+[missionVariables.SE_commodity]+"_"+[missionVariables.SE_economy_type]+"_"+"deviation"+"]");
			missionVariables.SE_missiontext_string = "SE_"+[missionVariables.SE_commodity]+"_"+[missionVariables.SE_deviation];
		} else {
			missionVariables.SE_economy_type = "industrial";
			missionVariables.SE_commodity = expandDescription("[SE_industrial_commodity]");
			missionVariables.SE_deviation = expandDescription("[SE_"+[missionVariables.SE_commodity]+"_"+[missionVariables.SE_economy_type]+"_"+"deviation"+"]");
			missionVariables.SE_missiontext_string = "SE_"+[missionVariables.SE_commodity]+"_"+[missionVariables.SE_deviation];
		}
		obj = {ID:this.name,Message:expandMissionText([missionVariables.SE_missiontext_string]),Pic:"SE-bloomberg.png",Music:"SE-stockmarket.ogg",Priority:2};
		if(this.logging) log(this.name,JSON.stringify(obj));
		this.passScreen(obj,1);
	} else if(this.logging) log(this.name,'Delay.');
	return;
}
// Pass the prepared object to Snoopers and set (or reset) variables
this.passScreen = function(obj,mode)
{
	if(this.logging) this.getLog('Status prepared:');
	// Pass the object and get errorcode back
	var a = worldScripts.snoopers.insertNews(obj);
	if(!a){ // On success
		if(mode) missionVariables.SE_status = "INJECTED"; // Set flag for inserted message
		if(this.logging) log(this.name,this.name+': Event passed. Status:'+missionVariables.SE_status);
	} else {
		if(a<0){ // If CRC is still stored or buffers full, add 2 more days and try again
			if(missionVariables.SE_status==="SET") missionVariables.SE_set = parseInt(missionVariables.SE_set)+2;
			if(missionVariables.SE_status==="RUNNING") missionVariables.SE_deadline = parseInt(missionVariables.SE_deadline)+2;
			return;
		}
		if(this.logging) log(this.name,'Snoopers returned:'+a);
		this.resetSpecialEvent(); // On failure reset everything...
	}
	if(this.logging) this.getLog('Status after insertion:');
	return;
}
// Callback from Snoopers
this.newsDisplayed = function(what){worldScripts["SE-main-script"].newsReaction(what); return;}
this.newsReaction = function(what)
{
	if(missionVariables.SE_galaxy_number!==null){
		if(missionVariables.SE_status === "INJECTED"){
			
			//fixed to work in Oolite 1.82 -spara-
			//System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).market = "SE-station-"+[missionVariables.SE_commodity]+"-"+[missionVariables.SE_deviation];
			System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).market_script = "bloomberg_market.js";
			//used in bloomberg_market.js -spara-
			missionVariables.SE_market_key = "SE-station-"+[missionVariables.SE_commodity]+"-"+[missionVariables.SE_deviation];
			
			var mi = expandMissionText("SE_market_information");
			if(this.logging) log(this.name,"Mission: "+mi);
			mission.setInstructions(mi,this.name);
			mission.markSystem({
			   system: missionVariables.SE_system_ID,
			   name: this.name,
			   markerColor: "blueColor",
			   markerShape: "MARKER_DIAMOND"
			});
			var event_duration = Math.floor(Math.random()*8) + 12;
			if(this.checkShort) missionVariables.SE_deadline = clock.days+1;
			else missionVariables.SE_deadline = clock.days + event_duration;
			missionVariables.SE_status = "RUNNING";
			if(this.logging) log(this.name,this.name+': Event set. Duration until:'+missionVariables.SE_deadline);
		} else if(missionVariables.SE_status === "RUNNING") this.resetSpecialEvent();
	}
	if(this.logging) this.getLog('Status after display:');
	return;
}
this.resetSpecialEvent = function()
{
	// Can be undefined if status=SET but not yet displayed
	if(missionVariables.SE_set && missionVariables.SE_galaxy_number!==null){
		
		//fixed to work in Oolite 1.82 -spara-
		//var a = System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).market;
		var a = System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).market_script;
		//if(a && a.substr(0,11) == "SE-station-") System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).market = null;
		if(a && a === "bloomberg_market.js") {
			System.infoForSystem([missionVariables.SE_galaxy_number],[missionVariables.SE_system_ID]).market_script = null;
			mission.unmarkSystem({system: missionVariables.SE_system_ID, name: this.name});
		}
	}
	mission.setInstructions(null,this.name);
	this.clearVars();
	if(this.logging) this.getLog('Status after cleaning:');
	return;
}
this.getLog = function(m)
{
	log(this.name,m);
	for(let prop in missionVariables){if(prop.substr(0,3)==='SE_') log(this.name,"mV["+prop+"] : "+missionVariables[prop]);}
	return;
}
